/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -C -c -S 1 -D -k '1,3,5,$' -t keyword.gperf  */
/* Autogenrated. */
#include "ksi.h"
struct ksi_keyword { const char *name; keyword_t id; };
#ifdef __GNUC__
__inline
#endif
static unsigned int hash(register const char *, 
			 register unsigned int);
#ifdef __GNUC__
__inline
#endif
static const struct ksi_keyword *in_word_set(register const char *, 
					     register unsigned int);

#define TOTAL_KEYWORDS 128
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 21
#define MIN_HASH_VALUE 14
#define MAX_HASH_VALUE 355
/* maximum key range = 342, duplicates = 3 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static const unsigned short asso_values[] =
    {
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356,  35, 356, 105,  78,   0,
        5,  65,  60,  75,  35,  91, 356,  10,  52,  22,
       25, 117, 110,   5,   0,  80,   0,   0,  55,  10,
      124,   5,  15, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356, 356, 356, 356, 356,
      356, 356, 356, 356, 356, 356
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 5:
        hval += asso_values[(unsigned char)str[4]];
      case 4:
      case 3:
        hval += asso_values[(unsigned char)str[2]];
      case 2:
      case 1:
        hval += asso_values[(unsigned char)str[0]];
        break;
    }
  return hval + asso_values[(unsigned char)str[len - 1]];
}

#ifdef __GNUC__
__inline
#endif
const struct ksi_keyword *
in_word_set (str, len)
     register const char *str;
     register unsigned int len;
{
  static const struct ksi_keyword wordlist[] =
    {
      {"trunc_mod", kw_trunc_mod},
      {"round_mod", kw_round_mod},
      {"uint", kw_uint},
      {"const", kw_const},
      {"return", kw_return},
      {"cond", kw_cond},
      {"const_func", kw_const_func},
      {"truth_or", kw_truth_or},
      {"truth_not", kw_truth_not},
      {"truth_xor", kw_truth_xor},
      {"truth_and", kw_truth_and},
      {"lt", kw_lt},
      {"unlt", kw_unlt},
      {"var", kw_var},
      {"trunc_div", kw_trunc_div},
      {"round_div", kw_round_div},
      {"eq", kw_eq},
      {"uneq", kw_uneq},
      {"min", kw_min},
      {"gt", kw_gt},
      {"mult", kw_mult},
      {"ungt", kw_ungt},
      {"struct", kw_struct},
      {"func", kw_func},
      {"enum", kw_enum},
      {"ne", kw_ne},
      {"int", kw_int},
      {"unit", kw_unit},
      {"extern", kw_extern},
      {"convert", kw_convert},
      {"modify", kw_modify},
      {"rshift", kw_rshift},
      {"indirect", kw_indirect},
      {"truth_orif", kw_truth_orif},
      {"truth_andif", kw_truth_andif},
      {"call", kw_call},
      {"attr", kw_attr},
      {"bit_not", kw_bit_not},
      {"bind", kw_bind},
      {"ptr", kw_ptr},
      {"addr", kw_addr},
      {"wfl", kw_wfl},
      {"le", kw_le},
      {"unle", kw_unle},
      {"ref", kw_ref},
      {"func_ptr", kw_func_ptr},
      {"weak", kw_weak},
      {"nil", kw_nil},
      {"comdat", kw_comdat},
      {"ordered", kw_ordered},
      {"parm", kw_parm},
      {"unordered", kw_unordered},
      {"enumdef", kw_enumdef},
      {"result", kw_result},
      {"ceil_mod", kw_ceil_mod},
      {"field", kw_field},
      {"ge", kw_ge},
      {"unge", kw_unge},
      {"fbuiltin", kw_fbuiltin},
      {"union", kw_union},
      {"component", kw_component},
      {"structdef", kw_structdef},
      {"rdiv", kw_rdiv},
      {"compound", kw_compound},
      {"lshift", kw_lshift},
      {"pure_func", kw_pure_func},
      {"void", kw_void},
      {"no_return", kw_no_return},
      {"exit", kw_exit},
      {"local", kw_local},
      {"ptr_call", kw_ptr_call},
      {"negate", kw_negate},
      {"no_limit_stack", kw_no_limit_stack},
      {"bit_ior", kw_bit_ior},
      {"non_lvalue", kw_non_lvalue},
      {"no_check_memory_usage", kw_no_check_memory_usage},
      {"float", kw_float},
      {"uniondef", kw_uniondef},
      {"packed", kw_packed},
      {"float_expr", kw_float_expr},
      {"func_ref", kw_func_ref},
      {"ceil_div", kw_ceil_div},
      {"floor_mod", kw_floor_mod},
      {"bit_andtc", kw_bit_andtc},
      {"fix_trunc", kw_fix_trunc},
      {"plus", kw_plus},
      {"bit_and", kw_bit_and},
      {"goto", kw_goto},
      {"size_of", kw_size_of},
      {"fix_round", kw_fix_round},
      {"builtin", kw_builtin},
      {"postdec", kw_postdec},
      {"section", kw_section},
      {"preinc", kw_preinc},
      {"bit_xor", kw_bit_xor},
      {"minus", kw_minus},
      {"block", kw_block},
      {"ffs", kw_ffs},
      {"artificial", kw_artificial},
      {"ptr_fcall", kw_ptr_fcall},
      {"aligned", kw_aligned},
      {"exact_div", kw_exact_div},
      {"label", kw_label},
      {"floor_div", kw_floor_div},
      {"fix_ceil", kw_fix_ceil},
      {"predec", kw_predec},
      {"nop", kw_nop},
      {"bool", kw_bool},
      {"fix_floor", kw_fix_floor},
      {"malloc_like", kw_malloc_like},
      {"abs", kw_abs},
      {"max", kw_max},
      {"fcall", kw_fcall},
      {"input_file", kw_input_file},
      {"suppress_debug", kw_suppress_debug},
      {"loop", kw_loop},
      {"public", kw_public},
      {"static_var", kw_static_var},
      {"static_ctor", kw_static_ctor},
      {"static_dtor", kw_static_dtor},
      {"postinc", kw_postinc},
      {"rrotate", kw_rrotate},
      {"exit_loop", kw_exit_loop},
      {"one_only", kw_one_only},
      {"ellipsis", kw_ellipsis},
      {"elipsis", kw_elipsis},
      {"lrotate", kw_lrotate},
      {"global", kw_global}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register const struct ksi_keyword *wordptr;
          register const struct ksi_keyword *wordendptr;
          register const struct ksi_keyword *resword;

          switch (key - 14)
            {
              case 0:
                resword = &wordlist[0];
                goto compare;
              case 5:
                resword = &wordlist[1];
                goto compare;
              case 15:
                resword = &wordlist[2];
                goto compare;
              case 16:
                resword = &wordlist[3];
                goto compare;
              case 17:
                resword = &wordlist[4];
                goto compare;
              case 20:
                resword = &wordlist[5];
                goto compare;
              case 21:
                resword = &wordlist[6];
                goto compare;
              case 29:
                resword = &wordlist[7];
                goto compare;
              case 30:
                wordptr = &wordlist[8];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 35:
                resword = &wordlist[10];
                goto compare;
              case 40:
                resword = &wordlist[11];
                goto compare;
              case 42:
                resword = &wordlist[12];
                goto compare;
              case 44:
                resword = &wordlist[13];
                goto compare;
              case 50:
                resword = &wordlist[14];
                goto compare;
              case 55:
                resword = &wordlist[15];
                goto compare;
              case 58:
                resword = &wordlist[16];
                goto compare;
              case 60:
                resword = &wordlist[17];
                goto compare;
              case 61:
                resword = &wordlist[18];
                goto compare;
              case 63:
                resword = &wordlist[19];
                goto compare;
              case 64:
                resword = &wordlist[20];
                goto compare;
              case 65:
                resword = &wordlist[21];
                goto compare;
              case 72:
                resword = &wordlist[22];
                goto compare;
              case 75:
                resword = &wordlist[23];
                goto compare;
              case 77:
                resword = &wordlist[24];
                goto compare;
              case 78:
                resword = &wordlist[25];
                goto compare;
              case 80:
                resword = &wordlist[26];
                goto compare;
              case 81:
                resword = &wordlist[27];
                goto compare;
              case 82:
                resword = &wordlist[28];
                goto compare;
              case 83:
                resword = &wordlist[29];
                goto compare;
              case 84:
                resword = &wordlist[30];
                goto compare;
              case 87:
                resword = &wordlist[31];
                goto compare;
              case 90:
                resword = &wordlist[32];
                goto compare;
              case 91:
                resword = &wordlist[33];
                goto compare;
              case 92:
                resword = &wordlist[34];
                goto compare;
              case 94:
                resword = &wordlist[35];
                goto compare;
              case 95:
                resword = &wordlist[36];
                goto compare;
              case 96:
                resword = &wordlist[37];
                goto compare;
              case 98:
                resword = &wordlist[38];
                goto compare;
              case 99:
                resword = &wordlist[39];
                goto compare;
              case 100:
                resword = &wordlist[40];
                goto compare;
              case 103:
                resword = &wordlist[41];
                goto compare;
              case 105:
                resword = &wordlist[42];
                goto compare;
              case 107:
                resword = &wordlist[43];
                goto compare;
              case 109:
                resword = &wordlist[44];
                goto compare;
              case 114:
                resword = &wordlist[45];
                goto compare;
              case 115:
                resword = &wordlist[46];
                goto compare;
              case 118:
                resword = &wordlist[47];
                goto compare;
              case 119:
                resword = &wordlist[48];
                goto compare;
              case 120:
                resword = &wordlist[49];
                goto compare;
              case 122:
                wordptr = &wordlist[50];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 123:
                resword = &wordlist[52];
                goto compare;
              case 124:
                resword = &wordlist[53];
                goto compare;
              case 125:
                resword = &wordlist[54];
                goto compare;
              case 126:
                resword = &wordlist[55];
                goto compare;
              case 128:
                resword = &wordlist[56];
                goto compare;
              case 130:
                resword = &wordlist[57];
                goto compare;
              case 131:
                resword = &wordlist[58];
                goto compare;
              case 132:
                resword = &wordlist[59];
                goto compare;
              case 134:
                resword = &wordlist[60];
                goto compare;
              case 135:
                resword = &wordlist[61];
                goto compare;
              case 136:
                resword = &wordlist[62];
                goto compare;
              case 138:
                resword = &wordlist[63];
                goto compare;
              case 139:
                resword = &wordlist[64];
                goto compare;
              case 140:
                resword = &wordlist[65];
                goto compare;
              case 141:
                resword = &wordlist[66];
                goto compare;
              case 145:
                resword = &wordlist[67];
                goto compare;
              case 146:
                resword = &wordlist[68];
                goto compare;
              case 147:
                resword = &wordlist[69];
                goto compare;
              case 156:
                resword = &wordlist[70];
                goto compare;
              case 157:
                resword = &wordlist[71];
                goto compare;
              case 161:
                resword = &wordlist[72];
                goto compare;
              case 162:
                resword = &wordlist[73];
                goto compare;
              case 163:
                resword = &wordlist[74];
                goto compare;
              case 167:
                resword = &wordlist[75];
                goto compare;
              case 168:
                resword = &wordlist[76];
                goto compare;
              case 170:
                resword = &wordlist[77];
                goto compare;
              case 172:
                resword = &wordlist[78];
                goto compare;
              case 173:
                resword = &wordlist[79];
                goto compare;
              case 174:
                resword = &wordlist[80];
                goto compare;
              case 175:
                resword = &wordlist[81];
                goto compare;
              case 177:
                resword = &wordlist[82];
                goto compare;
              case 178:
                resword = &wordlist[83];
                goto compare;
              case 179:
                resword = &wordlist[84];
                goto compare;
              case 180:
                resword = &wordlist[85];
                goto compare;
              case 181:
                resword = &wordlist[86];
                goto compare;
              case 182:
                resword = &wordlist[87];
                goto compare;
              case 183:
                resword = &wordlist[88];
                goto compare;
              case 184:
                resword = &wordlist[89];
                goto compare;
              case 187:
                resword = &wordlist[90];
                goto compare;
              case 188:
                resword = &wordlist[91];
                goto compare;
              case 189:
                resword = &wordlist[92];
                goto compare;
              case 192:
                resword = &wordlist[93];
                goto compare;
              case 195:
                resword = &wordlist[94];
                goto compare;
              case 198:
                resword = &wordlist[95];
                goto compare;
              case 206:
                resword = &wordlist[96];
                goto compare;
              case 209:
                resword = &wordlist[97];
                goto compare;
              case 213:
                resword = &wordlist[98];
                goto compare;
              case 217:
                resword = &wordlist[99];
                goto compare;
              case 219:
                resword = &wordlist[100];
                goto compare;
              case 220:
                resword = &wordlist[101];
                goto compare;
              case 225:
                resword = &wordlist[102];
                goto compare;
              case 227:
                resword = &wordlist[103];
                goto compare;
              case 230:
                resword = &wordlist[104];
                goto compare;
              case 232:
                resword = &wordlist[105];
                goto compare;
              case 234:
                resword = &wordlist[106];
                goto compare;
              case 237:
                resword = &wordlist[107];
                goto compare;
              case 239:
                resword = &wordlist[108];
                goto compare;
              case 253:
                resword = &wordlist[109];
                goto compare;
              case 254:
                resword = &wordlist[110];
                goto compare;
              case 259:
                resword = &wordlist[111];
                goto compare;
              case 260:
                resword = &wordlist[112];
                goto compare;
              case 262:
                resword = &wordlist[113];
                goto compare;
              case 265:
                resword = &wordlist[114];
                goto compare;
              case 269:
                resword = &wordlist[115];
                goto compare;
              case 271:
                resword = &wordlist[116];
                goto compare;
              case 272:
                resword = &wordlist[117];
                goto compare;
              case 273:
                wordptr = &wordlist[118];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 274:
                resword = &wordlist[120];
                goto compare;
              case 280:
                resword = &wordlist[121];
                goto compare;
              case 296:
                resword = &wordlist[122];
                goto compare;
              case 298:
                resword = &wordlist[123];
                goto compare;
              case 301:
                resword = &wordlist[124];
                goto compare;
              case 309:
                resword = &wordlist[125];
                goto compare;
              case 332:
                resword = &wordlist[126];
                goto compare;
              case 341:
                resword = &wordlist[127];
                goto compare;
            }
          return 0;
        multicompare:
          while (wordptr < wordendptr)
            {
              register const char *s = wordptr->name;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return wordptr;
              wordptr++;
            }
          return 0;
        compare:
          {
            register const char *s = resword->name;

            if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
              return resword;
          }
        }
    }
  return 0;
}

static const char *keyword_names[] = {
	"ERROR",
	"abs",
	"addr",
	"aligned",
	"artificial",
	"attr",
	"bind",
	"bit_and",
	"bit_andtc",
	"bit_ior",
	"bit_not",
	"bit_xor",
	"block",
	"bool",
	"builtin",
	"call",
	"ceil_div",
	"ceil_mod",
	"comdat",
	"component",
	"compound",
	"cond",
	"const",
	"const_func",
	"convert",
	"elipsis",
	"ellipsis",
	"enum",
	"enumdef",
	"eq",
	"exact_div",
	"exit",
	"exit_loop",
	"extern",
	"fbuiltin",
	"fcall",
	"ffs",
	"field",
	"float",
	"float_expr",
	"floor_div",
	"floor_mod",
	"func",
	"func_ptr",
	"func_ref",
	"ge",
	"global",
	"goto",
	"gt",
	"indirect",
	"input_file",
	"int",
	"label",
	"le",
	"local",
	"loop",
	"lrotate",
	"lshift",
	"lt",
	"malloc_like",
	"max",
	"min",
	"minus",
	"modify",
	"mult",
	"ne",
	"negate",
	"nil",
	"no_check_memory_usage",
	"no_limit_stack",
	"no_return",
	"non_lvalue",
	"nop",
	"one_only",
	"ordered",
	"packed",
	"parm",
	"plus",
	"ptr",
	"ptr_call",
	"ptr_fcall",
	"public",
	"pure_func",
	"rdiv",
	"ref",
	"result",
	"return",
	"round_div",
	"round_mod",
	"rrotate",
	"rshift",
	"section",
	"static_ctor",
	"static_dtor",
	"static_var",
	"struct",
	"structdef",
	"suppress_debug",
	"trunc_div",
	"trunc_mod",
	"truth_and",
	"truth_andif",
	"truth_not",
	"truth_or",
	"truth_orif",
	"truth_xor",
	"uint",
	"uneq",
	"unge",
	"ungt",
	"union",
	"uniondef",
	"unit",
	"unle",
	"unlt",
	"unordered",
	"var",
	"void",
	"weak",
	"wfl",
	"fix_trunc",
	"fix_ceil",
	"fix_round",
	"fix_floor",
	"preinc",
	"postinc",
	"predec",
	"postdec",
	"size_of",
	0
};

const char *keyword_name(keyword_t kw)
{
	int k = (int)kw;

	if (k <= kw__error || k >= kw__LAST)
		return keyword_names[0];
	else
		return keyword_names[kw];
}

keyword_t lookup_keyword(const char *ptr, int len)
{
	const struct ksi_keyword *w;

	w = in_word_set(ptr, len);

	if (w)
		return w->id;
	else
		return kw__error;
}
